Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Halide::Internal::IRVisitor Class Reference

A base class for algorithms that need to recursively walk over the IR. More...

`#include <IRVisitor.h>`

Inheritance diagram for Halide::Internal::IRVisitor:

## Public Member Functions
| IRVisitor ()=default
virtual | ~IRVisitor ()=default

## Protected Member Functions
virtual void | visit (const IntImm *)
virtual void | visit (const UIntImm *)
virtual void | visit (const FloatImm *)
virtual void | visit (const StringImm *)
virtual void | visit (const Cast *)
virtual void | visit (const Reinterpret *)
virtual void | visit (const Add *)
virtual void | visit (const Sub *)
virtual void | visit (const Mul *)
virtual void | visit (const Div *)
virtual void | visit (const Mod *)
virtual void | visit (const Min *)
virtual void | visit (const Max *)
virtual void | visit (const EQ *)
virtual void | visit (const NE *)
virtual void | visit (const LT *)
virtual void | visit (const LE *)
virtual void | visit (const GT *)
virtual void | visit (const GE *)
virtual void | visit (const And *)
virtual void | visit (const Or *)
virtual void | visit (const Not *)
virtual void | visit (const Select *)
virtual void | visit (const Load *)
virtual void | visit (const Ramp *)
virtual void | visit (const Broadcast *)
virtual void | visit (const Let *)
virtual void | visit (const LetStmt *)
virtual void | visit (const AssertStmt *)
virtual void | visit (const ProducerConsumer *)
virtual void | visit (const Store *)
virtual void | visit (const Provide *)
virtual void | visit (const Allocate *)
virtual void | visit (const Free *)
virtual void | visit (const Realize *)
virtual void | visit (const Block *)
virtual void | visit (const Fork *)
virtual void | visit (const IfThenElse *)
virtual void | visit (const Evaluate *)
virtual void | visit (const Call *)
virtual void | visit (const Variable *)
virtual void | visit (const For *)
virtual void | visit (const Acquire *)
virtual void | visit (const Shuffle *)
virtual void | visit (const Prefetch *)
virtual void | visit (const HoistedStorage *)
virtual void | visit (const Atomic *)
virtual void | visit (const VectorReduce *)

## Detailed Description

A base class for algorithms that need to recursively walk over the IR.

The default implementations just recursively walk over the children. Override the ones you care about.

Definition at line 19 of file IRVisitor.h.

## Constructor & Destructor Documentation

## ◆ IRVisitor()

Halide::Internal::IRVisitor::IRVisitor | ( |  | ) |
| default

## ◆ ~IRVisitor()

virtual Halide::Internal::IRVisitor::~IRVisitor | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ visit() [1/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const IntImm * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

Referenced by Halide::SimdOpCheckTest::check_one(), and Halide::Internal::LambdaVisitor< Lambdas >::visit_base().

## ◆ visit() [2/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const UIntImm * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [3/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const FloatImm * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [4/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const StringImm * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [5/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Cast * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [6/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Reinterpret * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [7/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Add * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [8/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Sub * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [9/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Mul * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [10/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Div * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [11/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Mod * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [12/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Min * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [13/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Max * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [14/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const EQ * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [15/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const NE * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [16/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const LT * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [17/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const LE * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [18/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const GT * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [19/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const GE * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [20/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const And * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [21/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Or * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [22/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Not * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [23/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Select * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [24/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Load * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [25/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Ramp * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [26/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Broadcast * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [27/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Let * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [28/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const LetStmt * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [29/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const AssertStmt * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [30/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const ProducerConsumer * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [31/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Store * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [32/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Provide * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [33/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Allocate * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [34/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Free * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [35/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Realize * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [36/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Block * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [37/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Fork * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [38/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const IfThenElse * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [39/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Evaluate * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [40/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Call * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::CodeGen_GPU_C, Halide::Internal::HostClosure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [41/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Variable * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [42/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const For * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::HostClosure, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [43/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Acquire * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [44/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Shuffle * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::CodeGen_GPU_C, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [45/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Prefetch * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [46/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const HoistedStorage * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [47/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const Atomic * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, Halide::Internal::Closure, and Halide::Internal::LambdaVisitor< Lambdas >.

## ◆ visit() [48/48]

virtual void Halide::Internal::IRVisitor::visit | ( | const VectorReduce * |  | ) |
| protected virtual

Reimplemented in Halide::Internal::Closure, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_GPU_C, Halide::Internal::CodeGen_LLVM, Halide::Internal::CodeGen_Posix, Halide::Internal::IRPrinter, Halide::Internal::IRGraphVisitor, and Halide::Internal::LambdaVisitor< Lambdas >.

The documentation for this class was generated from the following file:

- src/IRVisitor.h